#include "ltree.hpp"

extern Texture *render512_0;
extern PostProc filter;

Vector **model;
const int verts=24;

int beattime;
float lookfrom;

// bg effects holder
float backgroundy;

void createModel() {

	int i,j;
	const int height=20;
	const Vector keskipiste(0, -height*0.5f, 0);
	const int kaulah=5;
	
	// Bezieri pullon tekoon
	QuadraticBezierCurve bez( Vector(0,0,0), Vector(1.7f,0,0), Vector(2.3f,0,0));
	// pohjan kaltevuus
	QuadraticBezierCurve bez2( Vector(0,0,0), Vector(0.05f,0,0), Vector(0.1f,0,0));
	
	// Pystysuoraseinm
	for (i=0; i<verts; i++)
	{
		//y kasvaa, x muovautuu, z = 0
		const float kohta = (i / (float)verts);

		//puoliympyr
		const float ypos = kohta*height;
		const float xpos = (float)  ( 3.0f - bez.getValue( calcPosInt(i, 17  ,20 )).x );
		const float zpos = 0;

		 model[0][i] = Vector(xpos, ypos, zpos) + keskipiste;
		 if(i==0) {
			 model[0][i].y+=0.6f;
			 model[0][i].x-=1;
		 }
		 if(i==verts-1) {
			 model[0][i].x-=0.1f;
			 model[0][i].y-=0.6f;
		 }
	}

	i=0; 
	j=0;

	// Pyrytetn origon ympri jotta saadaan ympyr
	Matrix rot;
	for (i=0; i<verts; i++)
	{
		//pyrytetn y-akselin ympri
		const float pos = i / (float)verts;
		const float step = 1.0f / (float)verts;
		rot.makeRotation(0, pos*4*3.141592f, 0);
		for (j=0; j<verts; j++)
		{
			model[i][j] = model[0][j]*rot;
		}
	}



}

void drawBottle() {
		int i, j;
		for (i=0;i<verts;i++) {
			for (j=0;j<verts-1;j++)	// don't draw the last 1
			{	
				glVertex3fv((float *)&(model[(i+1)%verts][(j)%verts]));
				glVertex3fv((float *)&(model[(i+1)%verts][(j+1)%verts]));
				glVertex3fv((float *)&(model[(i)%verts][(j+1)%verts]));
				glVertex3fv((float *)&(model[(i)%verts][(j)%verts]));			
			}
		}
}

bool ltree(float aika, bool dobeat) {

	// loop vars
	int i,k;
	int drawtype;
	float alpha;

	const int	switch_rotate_style		= 203000;
	glLoadIdentity(); 

	
	// Crash
	lookfrom=0.3f;
	lookfrom = 0.3f+calcPosInt(originalaika, switch_rotate_style, switch_rotate_style+1000);
	
	
/*	if(aika<0.4)
	gluLookAt( (lookfrom-0.5)*10,lookfrom*50+10,(lookfrom-0.5)*10, 
		0, 0, 0, 
		0, 1, sin(aika*240));	
	else 
*/
	gluLookAt( 
		(lookfrom-0.5)*50, lookfrom*10+30, 80, 
		sin(aika*19)*5.0f, -20, cos(aika*15)*5.0f, 
		0, 1, sin(aika*14)/2.0f);
/*
	if(aika<0.6)
		glRotatef(aika*260,1,1,1);
	else
		glRotatef(0.6f*260,1,1,1);
*/

	// enable alphablending
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	
	glEnable(GL_DEPTH_TEST);

	drawtype=GL_QUADS;
	glLineWidth(1);
	glPointSize(3);

	for(k=0; k<100; k++) {

		glPushMatrix();
		
		// move bottles
		if(dobeat) 
			beattime = originalaika;

		glTranslatef((float)-40+(k%10)*10,
				 (calcPosInt(originalaika, beattime, beattime+1000)
				 -calcPosInt(originalaika, beattime+1000, beattime+1500)),
				 -45.0f+(((float)k)/10.0f)*12.0f); 
		
		// rotate style
//		if(originalaika>switch_rotate_style)		 
//		 glRotatef(aika*600*lookfrom*((k*k%50)/(float)50),
//					0.4f,1,0.5f);

//		else 
		 glRotatef(aika*600,0.4f,1,0.5f);
		
		// alpha - used for in and out fading
		alpha = 0;
		alpha=calcPosFloat(aika,0,0.2f)*0.6f;

		// Calculate color for bottles
		glColor4f(0.25f,0.45f,0.9f,alpha); 

		// Kameran flipatessa topdowniin siirrytn piirtmn linej
		drawtype=GL_LINE_STRIP; 
		
		/*if(aika>to_filled_start) // Smoothly fade to drawtype - QUADS
		if(calcPosFloat(aika, to_filled_start, to_filled_end)*(float)100>k) {
			  //glColor4f(0.3f,0.6f,0.6f,0.3f);
			glColor4f(0.3f,0.45f,0.9f,alpha); 
 			  drawtype=GL_QUADS;
			  glDisable(GL_DEPTH_TEST);
			}
*/
			glBegin(drawtype);
				drawBottle();
			glEnd();

		// draw the bottom of the bottle
		glColor4f(1,1,1, alpha*0.2f );

		if(drawtype==GL_QUADS) drawtype=GL_POLYGON;

			glBegin(drawtype);
				for (i=0;i<verts-0;i++)
				{
						glVertex3fv((float *)&(model[(i+1)%verts][0]));
				}
			glEnd();

		glPopMatrix();
	}


    
    
		
			glDisable(GL_DEPTH_TEST);
			
			glEnable(GL_BLEND);
			glBlendFunc(GL_ONE,GL_DST_ALPHA);
			const char *text[4] = 
			{ 
			  
			  "Greetings to",
              "all our friends",
              "and Simulaatio",
              "visitors"

			};

			float last_t=1.0f;
		    
            last_t = calcPosFloat(aika, 0.05f, 0.25)
						 - calcPosFloat(aika,0.95f, 1.0f);
			
            float drive_in = 0.0f;

            drive_in = calcPosFloat(aika,0.0f, 0.35f)
                + calcPosFloat(aika, 0.8f, 0.9f);

            glLoadIdentity();
            glRotatef(20.0f,-1.0f,1.0f,0);
            glTranslatef(0.0f,2.0f, -10.0f);

			for(i=0; i<4; i++)  {
				
				glColor4f(last_t*0.8f,0.8f*last_t,last_t*0.8f, last_t);

				glPushMatrix();
				
				glTranslatef(-14+drive_in*14.0f,-0.8f*i,0);
				
				font_write3d(text[i]); 
	 
				glPopMatrix();

			}
		
			


    
    
    
    /*
	// TYN ALLA
	if(aika<0.25f)		
		filter.glow(0.6f, 8, 0.008f, 
		calcPosFloat(aika,0,0.01f)*0.15f-calcPosFloat(aika,0.2f,0.25f)*0.15f, 
		0.9f);
*/
	return true;
}



void ltree_init() {
	
	int i;
	model = new Vector*[verts];
	
	for (i=0; i<verts; i++)
		model[i] = new Vector[verts];

	createModel();
	lookfrom=0;

	// tausta siirrot
	backgroundy=0;

} 

void ltree_free() {
	int i;
	for (i=0; i<verts; i++)
		delete [] model[i];
	delete [] model;
}
 
