#include "../stuff.hpp"
#include "../matikka.h"
#include "ranta.hpp"

// IDEA

// Nosta aina beatilla vuori lineaarisesti interpoloiden - eri nostofunktio, 
// tai normalisoi aina!

Vector *grid;
int rantagridx = 100;
int rantagridz = 100;
int grid_x = 10;
int grid_z = 10;
int count=rantagridx*rantagridz;
const float rantaxsize = 0.2f;
const float rantazsize = 0.2f;

void AddHill()
{
	// VHENN NOSTOA!

	float fRadius = randFloat()*10+10;
	
	// vuoren keskusta
	int x, y;
	x = (int) randFloat()*rantagridx;
	y = (int) randFloat()*rantagridz;

	// square the hill radius so we don't have to square root the distance 
	float fRadiusSq = fRadius * fRadius;
	float fDistSq;
	float fHeight;
	
	// find the range of cells affected by this hill
	int xMin = (int) ( x - fRadius - 1 ) ;
	int xMax = (int) ( x + fRadius + 1 ) ;
	// don't affect cell outside of bounds
	if( xMin < 1 ) xMin = 2;
	if( xMax >= rantagridx ) xMax = rantagridx - 2;
	
	int yMin = (int)(y - fRadius - 1);
	int yMax = (int)(y + fRadius + 1);
	// don't affect cell outside of bounds
	if( yMin < 1 ) yMin = 2;
	if( yMax >= rantagridz ) yMax = rantagridz - 2;
	
	// for each affected cell, determine the height of the hill at that point
	// and add it to that cell
	for( int h = xMin; h <= xMax; ++h )
	{
		for( int v = yMin; v <= yMax; ++v )
		{
			// determine how far from the center of the hill this point is
			fDistSq = (float ) (( x - h ) * ( x - h ) + ( y - v ) * ( y - v ));
			// determine the height of the hill at this point
			fHeight = fRadiusSq - fDistSq;
			fHeight/=8; 
			// don't add negative hill values (i.e. outside the hill's radius)
			if( fHeight > 0 )
			{
//				grid[x*y];
				grid[h+v*rantagridx].y+=fHeight;
				// h, v, fHeight );	
			}	
		}
	}
}

void normalize() {
	int i; 
	float max=0,min=50;
	for(i=0; i<count; i++) {
		if(grid[i].y>max) max = grid[i].y;
		if(grid[i].y<min) min = grid[i].y;
	}

	// then do the normalizing
	for(i=0; i<count; i++) {
		grid[i].y=(grid[i].y-min)/(max-min)*55;
	}
}

void ranta_init() {
	
	// random seed
	setSeed(12345);

	grid = new Vector[count];

	float y=0;

	// This just places the points
	int i,x=0,z=0;
	for(i=0; i<count; i++) {
		grid[i] = Vector((float)x,(float)y,(float)z);
		x+=grid_x;
		if(i%rantagridx==0) {
			x=0;
			z+=grid_z;
		}
	}
 	AddHill();
	normalize();
}


bool ranta(float aika, bool beat_handled) {
	
    glLoadIdentity();	// clear matrix
	gluLookAt(
		-200-1000+calcPosFloat(aika,0.0f,0.1f)*1000,
		250+calcPosFloat(aika,0.1f,0.8f)*550 -500+calcPosFloat(aika,0.0f,0.1f)*500 ,
		-250+600-calcPosFloat(aika,0.0f,0.1f)*600 -300+calcPosFloat(aika,0.0f,0.1f)*300 ,
		500,0,500, 
		0, 1,0);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_DEPTH_TEST);

	// Ulos
	float out_trans=0;
	out_trans = calcPosFloat(aika,0.85f,1.0f);
	glTranslatef(0,-out_trans*5000,0);
	
	glTranslatef(500,0,500);
	glRotatef(aika*3600, 0,-1,-out_trans);
	glTranslatef(-500,0,-500);

	GLfloat fogcolor[4]=  {0.0f, 0.0f, 0.3f, 0.2f};
	// beateilla listn vuori 
	if(!beat_handled) {
		AddHill();
		beat_handled=true;
		fogcolor[0] =0.0f;
		fogcolor[1] =0.0f;		
		fogcolor[2] =0.3f;
		fogcolor[3] =0.2f;		
	}
	else 		{
		fogcolor[0] =0.0f;
		fogcolor[1] =0.0f;		
		fogcolor[2] =0.0f;		
		fogcolor[3] =0.7f;		
	}
		
/*
		glFogi(GL_FOG_MODE, GL_LINEAR);	// Fog Mode
		glFogfv(GL_FOG_COLOR, fogcolor);			// Set Fog Color
		glFogf(GL_FOG_DENSITY, 0.45f);				// How Dense Will The Fog Be
		glHint(GL_FOG_HINT, GL_NICEST);			// Fog Hint Value
		glFogf(GL_FOG_START, 1.0f);				// Fog Start Depth
		glFogf(GL_FOG_END, 1800.0f);				// Fog End Depth
		glEnable(GL_FOG);					// Enables GL_FOG



	// LIGHT FOOLINGS
	glEnable(GL_LIGHTING);                     //enables lighting
    glEnable(GL_LIGHT0);                       //enables a light
    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,0); 
    glEnable(GL_COLOR_MATERIAL);

	glColorMaterial(GL_FRONT,GL_DIFFUSE);

	float black[4]={0,0.0,0.0 ,0};
	glMaterialfv(GL_FRONT,GL_AMBIENT, black);
	glMaterialfv(GL_FRONT,GL_SPECULAR,black);	
*/
	float scale = 0;
	float scale2 = 0;
	glBegin( GL_QUADS );
	for(int i=0; i+1<count-rantagridx; i++) {

		if(i%rantagridx!=0 && i+rantagridx+1<count) {
			 
			glNormal3f(0.0f, 1, 0.0f);   
			
			glColor3f(0.1f+calcPosFloat(grid[i].y,20,75),0.1f+calcPosFloat(grid[i].y, 0,25)*0.7f,0.3f);
 			 glVertex3f(grid[i].x,		grid[i].y-scale*500+scale2,	grid[i].z);

			glColor3f(0.1f+calcPosFloat(grid[i+rantagridx].y,20,75) ,0.1f+calcPosFloat(grid[i+rantagridx].y, 0,25)*0.7f,0.3f);
			 glVertex3f(grid[i+rantagridx].x,	grid[i+rantagridx].y-scale*500+scale2 ,	grid[i+rantagridx].z);
			  
			glColor3f(0.1f+calcPosFloat(grid[i+1+rantagridx].y,20,75),0.1f+calcPosFloat(grid[i+1+rantagridx].y, 0,25)*0.7f,0.3f);
			 glVertex3f(grid[i+1+rantagridx].x,grid[i+1+rantagridx].y-scale*500+scale2,grid[i+1+rantagridx].z);

			glColor3f(0.1f+calcPosFloat(grid[i+1].y,20,75),0.1f+calcPosFloat(grid[i+1].y, 0,25)*0.7f,0.3f);

			 glVertex3f(grid[i+1].x,	grid[i+1].y-scale*500+scale2  ,grid[i+1].z);
//		 }
		}
	}
glEnd();

	// Piirretn vaaleat koristeet
	float col = 1-calcPosFloat(aika,0.6f,0.8f);
	glLineWidth(4);
	glColor4f(col,col,col,calcPosFloat(aika,0,0.3f) );
		glBegin(GL_LINE_STRIP);
			glVertex3f(0,0,0);
			glVertex3f((float)grid_x*rantagridx, 0,	0);
			glVertex3f((float)grid_x*rantagridx, 0,	(float)grid_z*rantagridz);
			glVertex3f(0,				  0,		(float)grid_z*rantagridz);
			glVertex3f(0,				  0,		0);
		glEnd();




	glDisable(GL_LIGHT0);
	glDisable(GL_LIGHTING);
	return beat_handled;
}

void ranta_free() {
	delete [] grid;

} 
