#include "transition.h"


void trans(float aika, Texture *t1, Texture *t2) {

	float ang, f;

	f= 1 +calcPosFloat(aika, 0, 0.1f)*(-0.5f)
		 +calcPosFloat(aika, 0.9f, 1)*( 0.5f);

	ang = 180.0f * calcPosFloat(aika,0.2f,0.8f);

	trans_help(f,t1,t2,ang,
		1-f,false,false,1.0f
		);
	

}

// t1 fade from, t2 fade to
void trans_help(float scale, Texture *t1, Texture *t2, float angle, float fade, bool box, bool texture_walls, float texfade) {



	perspective2D(2,2);

	glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
	glEnable(GL_DEPTH_TEST);
 	glEnable(GL_TEXTURE_2D);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);


	glTranslatef(1,1,0);
	glRotatef(angle,0,1,0);

	glScalef(scale,scale,scale);

	 glBindTexture(GL_TEXTURE_2D, t1->ID);
     glColor4f(1,1,1,1);    
	 glBegin(GL_QUADS);
	  glTexCoord2f(0, 0);
      glVertex3f(-1.0f, -1.0f, 0.0f);
      glTexCoord2f(1, 0);
      glVertex3f(1.0f, -1.0f, 0.0f);
      glTexCoord2f(1, 1);
      glVertex3f(1.0f, 1.0f, 0.0f);
      glTexCoord2f(0, 1);
      glVertex3f(-1.0f, 1.0f, 0.0f);
	 glEnd();
	
	 // Texture koordinaatit eripin koska kuva 'peilaantuu' kntyess
	 if(t2!=NULL) {
	  glBindTexture(GL_TEXTURE_2D, t2->ID);
	  glBegin(GL_QUADS);
 	   glTexCoord2f(1 , 0);
       glVertex3f(-1.0f, -1.0f,-0.001f);
       glTexCoord2f(0, 0);
       glVertex3f(1.0f, -1.0f,-0.001f);
       glTexCoord2f(0, 1);
       glVertex3f(1.0f, 1.0f,-0.001f);
       glTexCoord2f(1, 1);
       glVertex3f(-1.0f, 1.0f,-0.001f);
	  glEnd();
	 }
	glDisable(GL_TEXTURE_2D);

	if(!texture_walls) {
	 glColor4f(0.5f,0.5f,0.8f,fade/2.0f);
	 glLineWidth(10);
	 glBegin(GL_LINE_STRIP);
	  glVertex3f(-1, -1, 0);
 	  glVertex3f( 1, -1, 0);
	  glVertex3f( 1,  1, 0);
	  glVertex3f(-1,  1, 0);
	  glVertex3f(-1, -1, 0);
	 glEnd();

	}

	if(box) {
		glScalef(1,1,1);
		
		if(!texture_walls) {

			glLineWidth(6);
			glColor4f(0.5f,0.5f,0.8f,fade/2.0f);
			
				glBegin(GL_LINES);
	 			 glVertex3f(-1, -1, 0);
				 glVertex3f(-2, -2, 0);
				 glVertex3f( 1, -1, 0);
				 glVertex3f(2, -2, 0);
 				 glVertex3f( 1,  1, 0);
				 glVertex3f(2, 2, 0);
				 glVertex3f(-1,  1, 0);
				 glVertex3f(-2, 2, 0);
				glEnd();

		} else {

			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, t1->ID);
			glColor4f(0.5f,0.5f,0.5f,texfade);
			glBegin(GL_QUADS);

				//yllaita
				glTexCoord2f(0,1);	 	
				glVertex3f(-1, -1, 0);
				glTexCoord2f(0,0);
				glVertex3f(-2, -2, 0);
				glTexCoord2f(1,0);
	 			glVertex3f(2, -2, 0);
				glTexCoord2f(1,1);
				glVertex3f(1, -1, 0);

				// oikee laita
				glTexCoord2f(0,1);	 	
				glVertex3f( 1, -1, 0);
				glTexCoord2f(0,0);	 	
				glVertex3f(2, -2, 0);
				glTexCoord2f(1,0);	 	
				glVertex3f(2, 2, 0);
				glTexCoord2f(1,1);	 	
				glVertex3f(1, 1, 0);
				
				//alalaita
				glTexCoord2f(0,1);	 	
				glVertex3f(1,1, 0);
				glTexCoord2f(0,0);	 	
				glVertex3f(2, 2, 0);
				glTexCoord2f(1,0);	 	
				glVertex3f(-2, 2, 0);
				glTexCoord2f(1,1);	 	
				glVertex3f(-1, 1, 0);

				// vasenlaita
				glTexCoord2f(0,1);	 	
				glVertex3f(-1, 1, 0);
				glTexCoord2f(0 ,0);	 	
				glVertex3f(-2, 2, 0);
				glTexCoord2f(1,0);	 	
				glVertex3f(-2, -2, 0);
				glTexCoord2f(1,1);	 	
				glVertex3f(-1, -1, 0);

			glEnd();
			//glDisable(GL_TEXTURE_2D);
			}
		glScalef(scale,scale,scale);
	}

/*	glColor4f(1,1,1,1);
	glPointSize(10);
	glBegin(GL_POINTS);
	 glVertex3f(-1, -1, 0.0f);
	 glVertex3f( 1, -1, 0.0f);
	 glVertex3f( 1,  1, 0.0f);
	 glVertex3f(-1,  1, 0.0f);
	glEnd();
*/
	// back to the 3d mode
	perspective3D();
	glDisable(GL_TEXTURE_2D);

}

void trans_init();
void trans_free();
 
