#include "ParticleEngine.h"

peParticle::peParticle(void) { } 

peParticle::peParticle(float x, float y, float z, 
				   float spdx, float spdy, float spdz, 
				   float lifetime) {
	this->position.x=x;
	this->position.y=y;
	this->position.z=z;
	this->spdx=spdx;
	this->spdy=spdy;
	this->spdz=spdz;
	this->lifetime=lifetime;
}

peParticle::~peParticle() { }

void peParticle::paint() {

	glEnable(GL_TEXTURE_2D);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_BLEND);

	glDisable(GL_DEPTH_TEST);
	glBindTexture(GL_TEXTURE_2D, particle_texture->ID);

	billboard(
		this->position,
		Vector(1,0,0),
		Vector(0,1,0),
		Vector(0,0,1),
		1.0f);

	glDisable(GL_TEXTURE_2D);

}

ParticleEngine::ParticleEngine() { 
	start = NULL;
	end   = NULL;
}
ParticleEngine::~ParticleEngine() { }


// Physics go here
void peParticle::tick() {

	this->position.x+=this->spdx;
	this->position.y+=this->spdy;
	this->position.z+=this->spdz;
	
	this->spdy+=GRAVITY_PARTICLE;
	this->lifetime--;
}

void ParticleEngine::free() {
	peParticle *next=start;
	while(next!=NULL) {
			next = start->next;
			delete start;
			start=next;
		}
}

void ParticleEngine::add(peParticle *p) {

		// Jos lista on tyhj, lis alkuun
		if(start==NULL){
			// Aseta alku ja loppu uudeksi 
			start=end=p;
		}else {
		// The list has something
			end->next=p;
			end=end->next;
		}
		// Varmistetaan ett listan loppu pysyy osoittimena tyhjn
		end->next=NULL;

}

void ParticleEngine::draw() {

		peParticle *actual=start, *prior=NULL;
		
		// Loopataan kunnes loppuu
		while(actual!=NULL){
			
			// Piirrelln jne
			if(actual->lifetime>0) {

				actual->tick();
				actual->paint();

				// DRAW HERE

			} else {
				// Dead one to be removed

						if(prior!=NULL) prior->next = actual->next; // Hop over current
						else start=actual->next;		// We are going to delete start, fix new start

						delete actual; 					// Poistetaan tmn hetkinen

						if(prior!=NULL) actual=prior;	// Hyptn edelliseen
						else actual=start;

					if(actual!=NULL){

						if(actual->next==NULL)			// Jos seuraava on tyhj..
							this->end=actual;

						if(prior==NULL)					// Jos edellinen on tyhj..
							start=actual;

					} 						
			}

		/* Liikutaan seuraavaan */
			prior=actual;
			if(actual!=NULL)
				actual=actual->next;
		}

}

void ParticleEngine::addEffect(int x, int y, int z, int amount) {
	 
		int n;
		float ang, rnd;
		rnd=0;
		ang=0;
		float xx = (float) x;
		float yy = (float) y;
		float zz = (float) z;

		// x,y place of birth 
		// type describes which kind of effect we want
			 			
			for(n=0; n<amount; n++) {
                
					rnd=randFloat();
					ang = rnd*2*3.14f;
					this->add(new peParticle( 
						xx,//+rnd*2.0f,
						yy,//+rnd*2.0f,
						zz,
						(cos(ang)*0.2f)*(randFloat()-0.5f),
						(sin(ang)*0.2f)*(randFloat()-0.5f),
						(sin(ang)*0.3f)*(randFloat()-0.5f), 
						250));

			}
}

 
