#pragma once

#include "stuff.hpp"
#include "primitives.hpp"


#define GRAVITY_PARTICLE -0.0003f
#define LIFETIME 300 // in frames


class peParticle
{
protected:
	Vector position;
	float spdx,spdy,spdz;
public:
	float lifetime;
	peParticle(void);
	peParticle(float x, float y, float z, float spdx, float spdy, float spdz, float lifetime);
	~peParticle(void);
	void tick();
	void paint();
	peParticle *next;
};

class ParticleEngine
{
public:
	ParticleEngine(void);
	~ParticleEngine(void);
	void addEffect(int x, int y, int z, int amount);
	void add(peParticle *p);
	void draw();
	void free();
private:
	peParticle *start, *end;	// linked list
}; 
