#include "postproc.hpp"

void PostProc::init()
{
}

void PostProc::prepare512()
{
    glViewport(0, 0, 512, 512);
}

// glowalpha = 0 niin saat normaalin kuvan
void PostProc::glow(float finalblur, int iterationcount, float spread, float glowalpha, float globalalpha)
{
	const int WX = 512;
	const int WY = 512;

    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, render512_0->ID); // dmsGetTexture("render0")->getID()
	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 0, 0, 512, 512, 0);
    glBindTexture(GL_TEXTURE_2D, render512_1->ID); // dmsGetTexture("render1")->getID()
	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 0, 0, 512, 512, 0);

    //nyt render0 = alkuperinen kuva
    perspective2D(1,1);
    glLoadIdentity();

    //ortho-moodissa tapahtuu kaikki

    //piirretn musta polygoni (=nollataan alkuperinen)
    glDisable(GL_BLEND);
    glDisable(GL_DEPTH_TEST); //depth test pois, ettei Zbuffer kuse
    glDepthMask(0);
//    glDisable(GL_DEPTH_MASK);
    glDisable(GL_TEXTURE_2D);

    glColor3f(0,0,0);
    glBegin(GL_QUADS);
    glVertex2f(0,0);
    glVertex2f(1,0);
    glVertex2f(1,1);
    glVertex2f(0,1);
    glEnd();

    int i;

    //nyt piirretn blurrattu 
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    glColor4f(1,1,1,globalalpha*glowalpha);

    for (i=0;i<iterationcount;i++)
    {
        const float xdisplace = i*spread;

        //vasemmalle

        glBegin(GL_QUADS);
        glTexCoord2f(0, 0);
        glVertex2f(-xdisplace, 0);
        glTexCoord2f(1, 0);
        glVertex2f(1-xdisplace, 0);
        glTexCoord2f(1, 1);
        glVertex2f(1-xdisplace, 1);
        glTexCoord2f(0, 1);
        glVertex2f(-xdisplace, 1);

        //oikealle
        glTexCoord2f(0, 0);
        glVertex2f( xdisplace, 0);
        glTexCoord2f(1, 0);
        glVertex2f(1+xdisplace, 0);
        glTexCoord2f(1, 1);
        glVertex2f(1+xdisplace, 1);
        glTexCoord2f(0, 1);
        glVertex2f( xdisplace, 1);
        glEnd();

        //displacetettu ruudulla, kopioidaan takaisin tekstuuriin se
        glBindTexture(GL_TEXTURE_2D, render512_0->ID);	// dmsGetTexture("render0")->getID()
    	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 0, 0, 512, 512, 0);
    }
    glColor4f(1,1,1,globalalpha*glowalpha);

    for (i=0;i<iterationcount;i++)
    {
        const float ydisplace = i*spread;

        glBegin(GL_QUADS);

        //yls
        glTexCoord2f(0, -ydisplace);
        glVertex2f(0, 0);
        glTexCoord2f(1, -ydisplace);
        glVertex2f(1, 0);
        glTexCoord2f(1, 1-ydisplace);
        glVertex2f(1, 1);
        glTexCoord2f(0, 1-ydisplace);
        glVertex2f(0, 1);

        //alas
        glTexCoord2f(0,  ydisplace);
        glVertex2f(0, 0);
        glTexCoord2f(1,  ydisplace);
        glVertex2f(1, 0);
        glTexCoord2f(1, 1+ydisplace);
        glVertex2f(1, 1);
        glTexCoord2f(0, 1+ydisplace);
        glVertex2f(0, 1);

        glEnd();

        //displacetettu ruudulla, kopioidaan takaisin tekstuuriin se
        glBindTexture(GL_TEXTURE_2D, render512_0->ID); //dmsGetTexture("render0")->getID()
    	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 0, 0, 512, 512, 0);
    }

    //piirretn lopullinen tulos ja sitten takaisin 3d-moodiin
	glViewport(0, 0, WX, WY);
    glDisable(GL_BLEND);
    glDisable(GL_DEPTH_TEST);
    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, render512_1->ID);	// dmsGetTexture("render1")->getID()
    glColor3f(globalalpha, globalalpha, globalalpha);

    glBegin(GL_QUADS);
    glTexCoord2f(0, 0);
    glVertex2f(0, 0);
    glTexCoord2f(1, 0);
    glVertex2f(1, 0);
    glTexCoord2f(1, 1);
    glVertex2f(1, 1);
    glTexCoord2f(0, 1);
    glVertex2f(0, 1);
    glEnd();

    //nyt on alkuperinen, plle additiivisella blendill blurri
    glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    glColor4f(1,1,1,globalalpha*finalblur);
    glBindTexture(GL_TEXTURE_2D, render512_0->ID); // dmsGetTexture("render0")->getID()
    glBegin(GL_QUADS);
    glTexCoord2f(0, 0);
    glVertex2f(0, 0);
    glTexCoord2f(1, 0);
    glVertex2f(1, 0);
    glTexCoord2f(1, 1);
    glVertex2f(1, 1);
    glTexCoord2f(0, 1);
    glVertex2f(0, 1);
    glEnd();
    
    perspective3D();
    glLoadIdentity();
    glDepthMask(1);
    //glEnable(GL_DEPTH_MASK);
    glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D);

}


// glowalpha = 0 niin saat normaalin kuvan
// Make sure the alphas add up to one
// void PostProc::blur(float finalblur, int iterationcount, float spread, float glowalpha, float globalalpha) {}

void PostProc::draw_grid(Texture *t, float alpha, float mx, float my, float r, float g, float b, float scale,
						 int type) {
    
	GLuint src, dst;
	if(type==0) {
		// 'lis tekstuurin'		
		src = GL_SRC_ALPHA;
		dst = GL_ONE;
	} else {
		// 'poistaa vrej'
		src = GL_ZERO;
		dst = GL_ONE_MINUS_SRC_ALPHA;
	}

	perspective2D(1,1);
    glLoadIdentity();

	//nyt piirretn blurrattu 
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
	glDisable(GL_DEPTH_TEST);
	glBlendFunc(src, dst);

    glColor4f(r,g,b, alpha);

    glEnable(GL_TEXTURE_2D);
    glBindTexture(GL_TEXTURE_2D, t->ID);	

	//	glScalef(scale,scale,scale);
	// Tekstuurin skaalausfaktori

	// MoveX , MoveY - tekstuuriliikkuu
	// mx = 
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT); 
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);

    glBegin(GL_QUADS);
    glTexCoord2f(((0+mx)/128.0f)*scale, ((0+my)/128.0f)*scale);
    glVertex2f(0, 0);
    glTexCoord2f((1+(0+mx)/128.0f)*scale, ((0+my)/128.0f)*scale);
    glVertex2f(1, 0);
    glTexCoord2f((1+(0+mx)/128.0f)*scale, (1+(0+my)/128.0f)*scale);
    glVertex2f(1, 1);
    glTexCoord2f(((0+mx)/128.0f)*scale, (1+(0+my)/128.0f)*scale);
    glVertex2f(0, 1);
    glEnd();

    perspective3D();
    glLoadIdentity();
    glDepthMask(1);
    glEnable(GL_DEPTH_TEST);
    glDisable(GL_BLEND);
	glDisable(GL_TEXTURE_2D); 
} 
