#include "primitives.hpp"

void billboard(Vector kohta, Vector x, Vector y, Vector z, float scale)
{
	glBegin(GL_QUADS);
	Vector v1 = kohta - x*scale - y*scale;
	Vector v2 = kohta + x*scale - y*scale;
	Vector v3 = kohta + x*scale + y*scale;
	Vector v4 = kohta - x*scale + y*scale;

	glTexCoord2f(0, 0);
	glVertex3fv((float *)&v1);
	glTexCoord2f(1, 0);
	glVertex3fv((float *)&v2);
	glTexCoord2f(1, 1);
	glVertex3fv((float *)&v3);
	glTexCoord2f(0, 1);
	glVertex3fv((float *)&v4);
	glEnd();
}
/*
void filledcircle(Vector &kohta, float radius)
{
	int j;
	const int ympyrastrips = 48;
	glBegin(GL_POLYGON);
//	glColor4f(0,0,0,alpha);
	for (j=0;j<ympyrastrips;j++)
	{
		const float ympkohta = 2*3.141592f*j / (ympyrastrips-1);
		Vector v = kohta + Vector((float)sin(ympkohta), (float)cos(ympkohta), 0)*radius;
		glVertex3fv((float *)&v);

	}
	glEnd();

}
void circle(Vector &kohta, float radius)
{
	int j;
	const int ympyrastrips = 48;
	glBegin(GL_LINE_STRIP);
	for (j=0;j<ympyrastrips;j++)
	{
		const float ympkohta = 2*3.141592f*j / (ympyrastrips-1);
		Vector v = kohta + Vector((float)sin(ympkohta), (float)cos(ympkohta), 0)*radius;
		glVertex3fv((float *)&v);

	}
	glEnd();
}
*/
 
