#include "stuff.hpp"


void perspective2D(float width, float height)
{
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();	
	glOrtho(0,width, 0,height,-50,500);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix(); 
	glLoadIdentity();
}
void perspective3D()
{
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
}

const bool testaaPos(const int aika, const int ajat[])
{
	int alku = ajat[0];
	int loppu = ajat[1];

	if (aika >= alku && aika <= loppu)
		return true;
	else 
		return false;
}

const float laskePos(const int aika, const int ajat[])
{

	int alku = ajat[0];
	int loppu = ajat[1];
	if (aika <= alku)
		return 0;
	if (aika >= loppu)
		return 1;
	const float pos = (float)(aika-alku) / (loppu-alku);
	return pos;
}

float calcPosInt(int value, int limit1, int limit2)
{
	if (value <= limit1)
		return 0;
	if (value >= limit2)
		return 1;
	else
		return (float)(value-limit1)/(limit2-limit1);
}

//interpoloi, palauttaa 0 jos value1 < limit1, palauttaa 0..1 jos vliss, 1 jos menee yli
float calcPosFloat(float value, float limit1, float limit2)
{
	if (value <= limit1)
		return 0;
	if (value >= limit2)
		return 1;
	else
		return (float)(value-limit1)/(limit2-limit1);
}

float calcSaturate(float value, float limit1, float limit2, float multiply)
{
	float pos, arvo;
	if (value <= limit1)
		return 0;
	if (value >= limit2)
		return 0;
	else
		pos = (float)(value-limit1)/(limit2-limit1);

	arvo = (float)sin(pos*3.141592f)*multiply;
	if (arvo < 0) //TSS SIZEOPTAUS?
		arvo = 0;
	if (arvo > 1)
		arvo = 1;

	return arvo;
}

void textures_init()
{
	int i;
	const unsigned int alpha = 255<<24;

	render512_0 = new Texture(512, 512);
	render512_1 = new Texture(512, 512);
	
	for (i=0;i<512*512;i++)
	{
		render512_0->data[i] = (unsigned long)alpha;
		render512_1->data[i] = (unsigned long)alpha;
	}

	int offset = 0;
	unsigned long *boxes = new unsigned long[128*128];
	unsigned long *rings = new unsigned long[128*128];
	unsigned long *circles = new unsigned long[128*128];
	unsigned long *circles2 = new unsigned long[128*128];
	unsigned long *pillars = new unsigned long[128*128];
	unsigned long *particle = new unsigned long[64*64];

	int x,y;
	for (y=-64;y<64;y++) {
		for (x=-64;x<64;x++) {

			boxes[offset] = 0x00000000;
			rings[offset] = 0x00000000;
			circles[offset] = 0x00000000;
			circles2[offset] = 0x00000000;
			pillars[offset] = 0x00000000;

			// Vaakapalkit
			switch(abs(y%8)) {
				case 1:
				case 7:
					boxes[offset] += 0x66663131;
					break;
				case 2:
				case 6:
					boxes[offset] += 0x93993141;
					break;
				case 3:
				case 5:
					boxes[offset] += 0x72bb7272;
					break;
				case 4:
					boxes[offset] += 0x94dd9494;
					break;
				default:
					boxes[offset] += 0x10101010;
			 }
			
			// epkeskot rinkulat
			int dist = 8+(int)sqrt((float)(x-32)*(x-32)+(y-32)*(y-32));
			switch(dist%23) {
				case 1:
				case 7:
					rings[offset] += 0x31663131;
					break;
				case 2:
				case 6:
					rings[offset] += 0x41993141;
					break;
				case 3:
				case 5:
					rings[offset] += 0x72bb7272;
					break;
				case 4:
					rings[offset] += 0x94dd9494;
					break;
				default:
					rings[offset] += 0x10101010;
			 }


			// normaali rinkulat
			dist = 8+(int)sqrt((float)(x)*(x)+(y)*(y));
			int d2;
			if(dist>60) d2=0;
			switch(dist%15) {
				case 1:
				case 7:
					circles[offset] = 0x31663131;
					if(dist<60)	 circles2[offset] = 0x33333333;
 					break;
				case 2:
				case 6:
					circles[offset] = 0x41993141;
					if(dist<60)	 circles2[offset] = 0x55555555;
					break;
				case 3:
				case 5:
					circles[offset] = 0x72bb7272;
					if(dist<60) circles2[offset] = 0x88888888;
					break;
				case 4:
					circles[offset] = 0xbbbbbbbb;
					if(dist<60)	 circles2[offset] = 0xcccccccc;
					break;
				default:
					circles[offset] = 0x00000000;
					circles2[offset] = 0x00000000;
			 }

			// Pillars
			switch((int)(abs(x)/5)%10) {
				case 1:
					pillars[offset] = 0x77777777;
					break;
				case 7:
					pillars[offset] = 0x33333333;
					break;
				case 2:
					pillars[offset] = 0x44444444;
					break;
				case 6:
					pillars[offset] = 0x87878787;
					break;
				case 3:
					pillars[offset] = 0x55555555;
					break;
				case 5:
					pillars[offset] = 0x22222222;
					break;
				case 4:
					pillars[offset] = 0x94949494;
					break;
				case 8:
					pillars[offset] = 0xbbbbbbbb;
					break;
				default:
					pillars[offset] = 0x44444444 ;
			 }


			if(y>25)  
			 boxes[offset] += ((int) ((abs((y)/25.0f))*255.0f) )<<24;

//			if(sqrt((float)x*x+y*y)<25)
//					//boxes[offset] += calcPosFloat(50*sqrt((float)x*x+y*y);

			offset++;
		}
	}

	// Partikkeli
	offset=0;
	for (y=-32;y<32;y++) 
		for (x=-32;x<32;x++) {

			int dist = (int)sqrt((float)(x)*(x)+(y)*(y));
			dist = (int)(abs(dist))%45;
			if(dist<5)
			 particle[offset] = 0x66cccccc;
			else if(dist<10)
			 particle[offset] = 0x55999999;
			else if(dist<15)
			 particle[offset] = 0x44777777;
			else if(dist<20)
			 particle[offset] = 0x33555555;
			else if(dist<25)
			 particle[offset] = 0x22333333;
			else if(dist<30)
			 particle[offset] = 0x11222221;
			else 
			 particle[offset] = 0x00000000;
			offset++;
		 }
	

	particle_texture= new Texture(64,64, particle);
	particle_texture->upload();

	pillars_texture= new Texture(128,128, pillars);
	pillars_texture->upload();

	circle2_texture = new Texture(128,128, circles);
	circle2_texture->upload();

	circle_texture = new Texture(128,128, rings);
	circle_texture->upload();
	
	circle3_texture = new Texture(128,128, circles2);
	circle3_texture->upload();

	// striped texture
	box_texture = new Texture(128, 128, boxes);
	box_texture->upload();
	
	render512_0->upload();
	render512_1->upload();
	
	delete [] particle;
	delete [] pillars;
	delete [] circles;
	delete [] circles2;
	delete [] boxes;
	delete [] rings;
}


void textures_free()
{
	delete render512_0;
	delete render512_1;
	delete box_texture;
	delete circle_texture;
	delete circle2_texture;
	delete circle3_texture;
	delete particle_texture;
	delete pillars_texture;
	
}


// Takes texture into a buffer
void texture_buffer(Texture *t) {
	glEnable(GL_TEXTURE_2D);
	glBindTexture(GL_TEXTURE_2D, t->ID);
    glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 0, 0, 512, 512, 0);
	glDisable(GL_TEXTURE_2D);
	glLoadIdentity();
}
 
